package Clones;			# -*- perl -*-

use Util;
use Carp;
use Html;
use Messages;

use Exporter ();

@ISA    = ( Exporter );

@EXPORT = qw(
	     clones_that_cover
);

sub clones_that_cover {
    my($org,$location) = @_;
    my($contig,$min,$max,$b1,$e1,$good,$possible,$solid,$cid);

    (($location =~ /^(\S+)_(\d+)_(\d+)$/) &&
     (-s "$WIT2_Config::organisms/$org/Clones/expanded.clone.table"))
	|| return undef;

    if ($2 < $3)
    {
	($contig,$min,$max) = ($1,$2,$3);
    }
    else
    {
	($contig,$min,$max) = ($1,$3,$2);
    }
#    print STDERR "Clones: looking for $contig $min to $max\n";

    if (! $loaded_clones{"$org\t$contig"})
    {
	&load_clone_data($org,$contig);
#	print STDERR "loaded clone data\n";
    }

    ($clones = $loaded_clones{"$org\t$contig"}) || return ();

    $solid = []; $possible = [];
    foreach $clone (@$clones)
    {
	($cid,$b1,$e1,$good) = @$clone;
	if (($min >= $b1) && ($max <= $e1))
	{
	    if ($good)
	    {
		push(@$solid,$cid);
	    }
	    else
	    {
		push(@$possible,$cid);
	    }
	}
    }
    return ($solid,$possible);
}
    
sub load_clone_data {
    my($org,$contig) = @_;
    my($clones);
    
    $clones = [];
    foreach $_ (`grep \"$contig\_\" $WIT2_Config::organisms/$org/Clones/expanded.clone.table`)
    {
	chop;
	($cid,undef,$loc1,undef,$loc2,$len) = split(/\t/,$_);
	if ($loc1 && ($loc1 =~ /^(\S+)_(\d+)_(\d+)$/) && ($1 eq $contig))
	{
	    $b1 = $2; $e1 = $3; $min1 = &min($b1,$e1); $max1 = &max($b1,$e1);
	    if ($loc2 && ($loc2 =~ /^(\S+)_(\d+)_(\d+)$/) && ($1 eq $contig))
	    {
		$b2 = $2; $e2 = $3; $min2 = &min($b2,$e2); $max2 = &max($b2,$e2);
		push(@$clones,[$cid,&min($min1,$min2),&max($max1,$max2),1]);
	    }
	    else
	    {
		if ($b1 < $e1)
		{
		    push(@$clones,[$cid,$b1,$b1+($len-1),0]);
		}
		else
		{
		    push(@$clones,[$cid,$b1-($len-1),$b1,0]);
		}
	    }
	}
	elsif ($loc2 && ($loc2 =~ /^(\S+)_(\d+)_(\d+)$/) && ($1 eq $contig))
	{
	    $b2 = $2; $e2 = $3; $min2 = &min($b2,$e2); $max2 = &max($b2,$e2);

	    if ($b2 < $e2)
	    {
		push(@$clones,[$cid,$b2,$b2+($len-2),0]);
	    }
	    else
	    {
		push(@$clones,[$cid,$b2-($len-2),$b2,0]);
	    }
	}
    }
    $loaded_clones{"$org\t$contig"} = $clones;
}
    
1;

