package Cluster;			# -*- perl -*-

use Sim;
use ORF;
use Util;
use Messages;

require Exporter;
@ISA = (Exporter);
@EXPORT = qw(
	     function_cluster
	     ortholog_clusters
);

sub ortholog_clusters {
    my(@orgs) = @_;
    my(@good,$i,@clust,@core,%core,$x);
    
    @good = ();
    open(TMP,"<$WIT2_Config::global/clusters")
	|| wit_die "could not open clusters";
    while (defined($_ = <TMP>))
    {
	chop;
	@clust = split(/\t/,$_);
	$core  = pop @clust;
	if ($core)
	{
	    @core     = split(/,/,$core);
	    undef(%core);
	    foreach $x (@core)
	    {
		$core{substr($x,1,2)} = 1;
	    }
	    for ($i=0; ($i < @orgs) && $core{$orgs[$i]}; $i++) {}
	    if ($i == @orgs)
	    {
		push(@good,[@core]);
	    }
	}
    }
    close(TMP);
    return @good;
}
	    

sub function_cluster {
    my($rid,$cutoff,$linkage,$user) = @_;
    my($pair,$prots,$cluster,$cluster_func);

    if ($cluster_func = &func_ofO($rid))
    {
	if ($pair = &clusterS($rid,[\&connect_by_asserted_ortholog,$cluster_func,$user],"",$cutoff,1000))
	{
	    if ($linkage > 1)
	    {
		$pair = &trim_by_linkage($pair,$linkage);
	    }
	    ($prots, $cluster) = @$pair;
	    if (@$prots > 0)
	    {
		return $prots;
	    }
	    else
	    {
		return "";
	    }
	}
	else
	{
	    return "";
	}
    }
    return "";
}

sub connect_by_asserted_ortholog {
    my($prot,$cutoff,$func,$user) = @_;
    my(@ans,$set1,$sim,$id2);
    my(%cnt);

    @ans = ();
    $set1 = &orthologS(&get_simS($prot,1000,$cutoff),"");
    foreach $sim (@$set1)
    {
	$id2    = &id2S($sim);
	if (&func_ofO($id2,$user) eq $func)
	{
	    push(@ans,$sim);
	}
    }
    return \@ans;
}

1;
