package FuncOv;			# -*- perl -*-

use HashDB;
use Html;
use PW;
use Messages;

require Exporter;
@ISA = (Exporter);
@EXPORT = qw(
	        topic_to_pws
	        pw_to_topics
	        topic_to_functions
	        function_to_topics
	        topic_to_kegg
);


sub topic_to_pws {
    my($topic) = @_;
    my(@x);

    if (! $topic_to_pws_ref)
    {
	$topic_to_pws_ref = &opendbH("topic_pws");
    }
    
    if ($_ = &accessdbH($topic_to_pws_ref,$topic))
    {
	@x = split(/\t/,$_);
	return \@x;
    }
    return "";
}

sub pw_to_topics {
    my($pw) = @_;
    my(@x);

    if (! $pw_to_topics_ref)
    {
	$pw_to_topics_ref = &opendbH("pw_topics");
    }
    
    if ($_ = &accessdbH($pw_to_topics_ref,$pw))
    {
	@x = split(/\t/,$_);
	return \@x;
    }

    return "";
}

sub topic_to_functions {
    my($topic) = @_;
    my(@x);

    if (! $topic_to_functions_ref)
    {
	$topic_to_functions_ref = &opendbH("topic_func");
    }
    
    if ($_ = &accessdbH($topic_to_functions_ref,$topic))
    {
	@x = split(/\n/,$_);
	return \@x;
    }
    return "";
}

sub function_to_topics {
    my($function) = @_;
    my(@x);

    if (! $function_to_topics_ref)
    {
	$function_to_topics_ref = &opendbH("func_topics");
    }
    
    if ($_ = &accessdbH($function_to_topics_ref,$function))
    {
	@x = split(/\n/,$_);
	return \@x;
    }

    return "";
}

sub topic_to_kegg {
    my($topic) = @_;
    my(@kegg,$x);

    if (! $loaded_kegg_topic)
    {
	$loaded_kegg_topic = 1;

	@kegg = `cat $WIT2_Config::global/kegg_map_titles.table`;
	foreach $_ (@kegg)
	{
	    if ($_ =~ /^(\S+)\t(\S.*\S)\s*$/)
	    {
		$title_kegg{$1} = $2;
	    }
	}

	@kegg = `cat $WIT2_Config::global/kegg_topic.table`;
	foreach $_ (@kegg)
	{
	    if ($_ =~ /^KEGG:(\S+)\t(\S.*\S)\s*$/)
	    {
		if (! ($x = $topic_kegg{$2} ))
		{
		    $x = ($topic_kegg{$2} = []);
		}
		push(@$x,[$1,$title_kegg{$1}]);
	    }
	}

    }

    if ($x = $topic_kegg{$topic})
    {
	return $x;
    }
    else
    {
	return "";
    }
}
    
1;
