package HashDB;			# -*- perl -*-

use Carp;

require Exporter;
@ISA = (Exporter);
@EXPORT = qw(
	     opendbH
	     createdbH
	     closedbH
	     insertdbH
	     accessdbH
	     deletedbH
	     replacedbH
	     sync_dbH
);

use DB_File;
use Fcntl;
use Messages;

$global = $WIT2_Config::global;

sub createdbH {
    my($name) = @_;
    my($hash,$ref);

    $hash = {};
    if (-e "$global/$name.db") 
    { 
	print STDERR "removing $name.db\n"; 
	unlink("$global/$name.db"); 
    }

    $ref = tie %$hash, DB_File, 
               "$global/$name.db", 
               (O_RDWR | O_CREAT), 0664, $DB_File::DB_HASH;
    defined($ref) || return "";
    return [$ref,$hash,$name];
}

sub opendbH {
    my($name,$insert) = @_;
    my($hash,$ref);
    
    $hash = {};
    if (! $insert)
    {
	$ref = tie %$hash, DB_File, 
	           "$global/$name.db", 
	           O_RDWR, 0664, $DB_File::DB_HASH;
    }
    else
    {
	$ref = tie %$hash, DB_File, 
	           "$global/$name.db", 
	           O_RDWR, 0664, $DB_File::DB_HASH;
    }
    defined($ref) || return "";
    return [$ref,$hash];
}

sub sync_dbH {
    my($handle) = @_;

    $handle->[0]->sync();
}

sub closedbH {
    my($handle) = @_;

    $handle->[0]->sync();
    undef $handle->[0];

    untie %{$handle->[1]};

    if (@$handle == 3)
    {
	system "chmod 777 $global/$handle->[2].db";
    }
}

sub insertdbH {
    my($handle,$key,$data) = @_;

    $handle->[1]->{$key} = $data;
}

sub replacedbH {
    my($handle,$key,$data) = @_;

    $handle->[1]->{$key} = $data;
}

sub accessdbH {
    my($handle,$key) = @_;
    my($x);

    (defined($handle) && defined($key)) || confess "handle=$handle key=$key";
    if (defined($x = $handle->[1]->{$key}))
    {
	return $x;
    }
    else
    {
	return undef;
    }
}

sub deletedbH {
    my($handle,$key) = @_;

    delete($handle->[1]->{$key});
}

1;
