package Messages;

use WIT2_Config;

use Exporter ();
@ISA = (Exporter);

@EXPORT = qw (
	      html_error_trace
	      system_error
	      user_error
	      user_message
	      wit_die
	     );

$main::SIG{__DIE__} = \&wit_die;

sub html_error_trace {

    use strict;

    my ( $error,          # String displayed to the right in title bar
	 $traceP,         # Reference to error string or list 
	 $headflag        # If true prints Content-Type: text/html
       ) = @_;

    my @trace = @{ $traceP };

    my $service = $syst_nam;                  # From WIT2_config
    my $title = qq (System Error);

    my @output;  
    my ( $line, $routine, $called_at );

    if ( $headflag ) 
    {
	push @output,  
"Content-Type: text/html

<HTML>
<HEAD>
<TITLE> $service $title </TITLE>
</HEAD>

<BODY>
";
    }

    push @output, qq (
<TABLE CELLPADDING=0 CELLSPACING=2 WIDTH="100%">
<TR><TD>

<TABLE BORDER=0 BGCOLOR="#000000" WIDTH=100% CELLPADDING=2 CELLSPACING=0>
<TR><TD>
    <TABLE BGCOLOR="#FF4C4C" BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=5>
    <TR>
       <TD WIDTH="40%" ALIGN="left" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG><BIG><BIG>&nbsp;$service&nbsp;&nbsp;</BIG></BIG></BIG></STRONG>
	    </FONT></TD>
       <TD ALIGN="right" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG>$title</BIG></STRONG></FONT></TD>
    </TR>
    </TABLE>
    </TD>
</TR>
</TABLE>

</TD></TR>
</TABLE>

<TABLE CELLSPACING=3 CELLPADDING=2>
<TR>
   <TD ALIGN="right"><IMG SRC="$gifs_url/smallmoth.gif"></TD>
   <TD ALIGN="left"><BIG><STRONG><FONT COLOR="red">Message</FONT>: $error</STRONG></BIG></TD>
</TR>
<TR><TD></TD>
    <TD>This is an error that should not happen. It surfaces when
for example a file could not be found, opened, read, saved to, etc.
This again may be related to incomplete installation of our data, 
Berkeley DB, or even lack of disk space.
</TD></TR>
<TR><TD></TD>
);

    push @output, qq (
<TD><H4>Call Trace</H4>
<P>
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=4>
<TR><TD HEIGTH="30" BGCOLOR="#777777" ALIGN="left"><FONT COLOR="#FFFFFF"><STRONG>Routine</STRONG></FONT></TD>
    <TD HEIGTH="30" BGCOLOR="#777777" ALIGN="left"><FONT COLOR="#FFFFFF"><STRONG>Called at</STRONG></FONT></TD>
</TR>
);

    foreach $line ( @trace )
    {
	( $routine, $called_at ) = split /\s*called at\s*/, $line;

	push @output, qq (<TR>
<TD ALIGN="right" NOWRAP>$routine</TD>
<TD ALIGN="left" NOWRAP>$called_at</TD>
</TR>
);
    }

    push @output, qq (
</TD></TR></TABLE>
<BR>
<TR><TD ALIGN="right" VALIGN="top"><IMG SRC="$gifs_url/info.gif"></TD>
<TD>
<P>
If you are unable to cure the problem from the above message, please 
send an elecronic mail message to 
<P>
Niels Larsen, niels\@integratedgenomics.com
<P>
Please include as much detail as you think is relevant, including if 
possible the full URL (the long string you see in the browser location
window) to the page where you got the problem. 
</TD></TR></TABLE>
);

    if ( $headflag ) 
    {
	push @output, qq (
</BODY>
</HTML>
);
    }

    return @output;
}

sub system_error {

    my ( $title,          # String displayed to the right in title bar
	 $error,          # Reference to error string or list 
	 $selfurl,        # URL of calling page
	 $headflag        # Non-empty print Content-Type: text/html
       ) = @_;

    my $service = $syst_nam;  # From wit2_config
    my @output;               # HTML output

    my $string;

    if ( $headflag ) 
    {
	push @output,  
"Content-Type: text/html

<HTML>
<HEAD>
<TITLE> $service $title </TITLE>
</HEAD>

<BODY>
";
    }

    push @output, qq (
<TABLE CELLPADDING=0 CELLSPACING=2 WIDTH="100%"><TR><TD>
<TABLE BORDER=0 BGCOLOR="#000000" WIDTH=100% CELLPADDING=2 CELLSPACING=0>

<TR><TD>
    <TABLE BGCOLOR="#F04115" BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=5>
    <TR>
       <TD WIDTH="40%" ALIGN="left" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG><BIG><BIG>&nbsp;$service&nbsp;&nbsp;</BIG></BIG></BIG></STRONG>
	    </FONT></TD>
       <TD ALIGN="right" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG>$title</BIG></STRONG></FONT></TD>
    </TR>
    </TABLE>
</TD>
</TR>
</TABLE>
</TD>
);

    push @output, qq (
<TR><TD>
<TABLE BGCOLOR="#CCCCCC" WIDTH="100%" BORDER=4 CELLSPACING=0 CELLPADDING=10>
<TR><TD ALIGN="left">
);

    if ( ref $error and @{ $error } > 1 ) {
	
	push @output, "<H4>Ouch. These are errors that should not occur,</H4>\n<P>\n";

	push @output, "<OL>\n";

	foreach $string ( @{ $error } ) {
	    push @output, qq (<LI>$string<P>\n);
	} 

	push @output, "</OL>\n";
    } 
    elsif ( $error )
    {
	push @output, "<H4>Ouch. This is an error that should not occur,</H4><P>\n";

	push @output, "<UL>\n";

	if ( ref $error ) {
	    push @output, qq (<LI>$error->[0]<P>\n);
	} else {
	    push @output, qq (<LI>$error<P>\n);
	}

	push @output, "</UL>\n";
    }

    if ( $selfurl ) 
    {
	push @output, qq (<P><H4><A HREF="$selfurl">Return to the originating page.</A></H4>);
    }
	
    push @output, qq (
<P>
For now (there will be an automatic procedure for this), please send 
an elecronic mail message to 
<P>
Niels Larsen, niels\@integratedgenomics.com
<P>
Please include as much detail as you think is relevant, including if 
possible the full URL (the long string you see in the browser location
window) to the page where you got the problem. 
<P>

</TD>
</TR>
</TABLE>
</TD></TR></TABLE>
);

    if ( $headflag ) 
    {
	push @output, qq (
</BODY>
</HTML>
);
    }

    return @output;
}

sub user_error {

    my ( $title,          # String displayed to the right in title bar
	 $error,          # Reference to error string or list 
	 $selfurl,        # URL of calling page
	 $headflag        # Non-empty prints Content-Type: text/html
       ) = @_;

    my $service = $syst_nam;  # From wit2_config
    my @output;               # HTML output

    my $string;

    if ( $headflag ) 
    {
	push @output,  
"Content-Type: text/html

<HTML>
<HEAD>
<TITLE> $service $title </TITLE>
</HEAD>

<BODY>
";
    }

    push @output, qq (
<TABLE CELLPADDING=0 CELLSPACING=2 WIDTH="100%"><TR><TD>

<TABLE BORDER=0 BGCOLOR="#000000" WIDTH=100% CELLPADDING=2 CELLSPACING=0>
<TR><TD>
    <TABLE BGCOLOR="#FFA406" BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=5>
    <TR>
       <TD WIDTH="40%" ALIGN="left" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG><BIG><BIG>&nbsp;$service&nbsp;&nbsp;</BIG></BIG></BIG></STRONG>
	    </FONT></TD>
       <TD ALIGN="right" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG>$title</BIG></STRONG></FONT></TD>
    </TR>
    </TABLE>
    </TD>
</TR>
</TABLE>

</TD>
);

    push @output, qq (
<TR><TD>
<TABLE BGCOLOR="#CCCCCC" WIDTH="100%" BORDER=4 CELLSPACING=0 CELLPADDING=10>
<TR><TD ALIGN="left">
);

    if ( ref $error and @{ $error } > 1 ) {
	
	push @output, "<H4>Sorry, there were the following errors,</H4>\n<P>\n";

	push @output, "<OL>\n";

	foreach $string ( @{ $error } ) {
	    push @output, qq (<LI>$string<P>\n);
	} 

	push @output, "</OL>\n";
    } 
    elsif ( $error ) 
    {
	push @output, "<H4>Sorry, there was the following error,</H4><P>\n";

	push @output, "<UL>\n";
	
	if ( ref $error ) {
	    push @output, qq (<LI>$error->[0]<P>\n);
	} else {
	    push @output, qq (<LI>$error<P>\n);
	}

	push @output, "</UL>\n";
    }

    if ( $selfurl ) 
    {
	push @output, qq (<P><H4><A HREF="$selfurl">Return to the originating page.</A></H4>);
    }

    push @output, qq (
<P>
If you believe there is an error in the $service system, then please 
send a mail to 
<P>
Niels Larsen, niels\@integratedgenomics.com
<P>
Please include as much detail as you think is relevant, including if 
possible the full URL (the long string you see in the browser location
window) to the page where you see a problem. 
<P>

</TD>
</TR>
</TABLE>
</TD></TR></TABLE>
);

    if ( $headflag ) 
    {
	push @output, qq (
</BODY>
</HTML>
);
    }

    return @output;
}

sub user_message {

    my ( $title,          # String displayed to the right in title bar
	 $message,        # Reference to message string or list 
	 $selfurl,        # URL of calling page
	 $headflag        # Non-empty print Content-Type: text/html
       ) = @_;

    my $service = $syst_nam;  # From wit2_config
    my @output;               # HTML output

    if ( $headflag ) 
    {
	push @output,
"Content-Type: text/html

<HTML>
<HEAD>
<TITLE> $service User Message </TITLE>
</HEAD>

<BODY>
";
    }

    if ( $title ) 
    {
	push @output, qq (
<TABLE CELLPADDING=0 CELLSPACING=2 WIDTH=100%><TR><TD>
<TABLE BORDER=0 BGCOLOR="#000000" WIDTH=100% CELLPADDING=2 CELLSPACING=0>

<TR><TD>
    <TABLE BGCOLOR="#535CFF" BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=5>
    <TR>
       <TD WIDTH="40%" ALIGN="left" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG><BIG><BIG>&nbsp;$service&nbsp;&nbsp;</BIG></BIG></BIG></STRONG>
	    </FONT></TD>
       <TD ALIGN="right" NOWRAP>
            <FONT FACE="Arial,Helvetica" COLOR="#FFFFFF">
            <STRONG><BIG>$title</BIG></STRONG></FONT></TD>
    </TR>
    </TABLE>
</TD>
</TR>
</TABLE>
</TD>
<TR><TD>
);
    }

    push @output, qq (
<TABLE BGCOLOR="#CCCCCC" WIDTH="100%" BORDER=4 CELLSPACING=0 CELLPADDING=10>
<TR><TD ALIGN="left">
);

    if ( ref $message and @{ $message } > 1 ) {

	push @output, "<OL>\n";

	foreach $string ( @{ $message } ) {
	    push @output, qq (<LI>$string<P>\n);
	}

	push @output, "</OL>\n";
    }
    elsif ( $message ) 
    {
	push @output, "<UL>\n";
	
	if ( ref $message ) {
	    push @output, qq (<LI>$message->[0]<P>\n);
	} else {
	    push @output, qq (<LI>$message<P>\n);
	}

	push @output, "</UL>\n";
    }
	
    if ( $selfurl ) 
    {
	push @output, qq (<P><H4><A HREF="$selfurl">Return to the originating page.</A></H4>);
    }

#<P>
#If on the other hand you believe this is due to an defect of the 
#$service system, then please send a mail to 
#<P>
#Niels Larsen, niels\@integratedgenomics.com
#<P>
#Please include as much detail as you think is relevant, including if 
#possible the full URL (the long string you see in the browser location
#window) to the page where you see a problem. 
#<P>

    push @output, qq (
</TD>
</TR>
</TABLE>
);

    if ( $title ) 
    {
	push @output, 
"<P>
</TD></TR>
</TABLE>
";
    }

    if ( $headflag ) 
    {
	push @output, 
"</BODY>
</HTML>
";
    }

    return @output;
}

sub wit_die ($) {
    
    my $message = shift;

    my ( $error, $call );
    my ( @trace, @trace_table );

    use Carp; 
    eval { confess "$message" };
    
    ( $error, undef, @trace ) = split "\n", $@;

    @error = split ' ', $error;
    $#error -= 4;
    $error = join " ", @error;

    foreach $call ( @trace )
    {
	$call =~ s/^\s*(.+)\s*$/$1/;
    }

    if ( defined $ENV{"HTTP_HOST"} ) 
    {
	print &html_error_trace( $error, \@trace, 1 );
    }
    else 
    {
	print STDERR "\n";
	print STDERR "DIE-MESSAGE: $error\n\n";

	print STDERR " CALL TRACE: $trace[0]\n";

	for ( $call = 1; $call < @trace; $call++ )
	{
	    print STDERR "             $trace[$call]\n"
	}
	print STDERR "\n";
    }

    exit (0);
}


1;

