xpackage PROTEIN_STRUCTURE;			# -*- perl -*-

use HashDB;
use Exporter ();

@ISA    = ( Exporter );

@EXPORT = qw(
	     struct_ofO
);

sub assigned_structureO {
    my ($prot,$user,$mode)=@_;
    my $graphic_length=150;
    my $ref=&opendbH("protein_structure");
    my $structure_string=&accessdbH($ref,$prot);
    my ($sequence_length,$hp_text)=$structure_string=~/(\d+)(.*)/;
    $hp_text=~s/\(|\)|\,/ /g;
    @hp_regions=split /\s+/, $hp_text;
    shift @hp_regions;
    return [@hp_regions] if $mode eq "list";
    return "<FONT SIZE=-2>no structure defined</FONT>" unless @hp_regions;
    my $height=3;
    my $width_scale=$graphic_length/$sequence_length;
    my ($hp_start,$hp_end,$hp_length);
    my $hp_endpoint=0;
    my $hp_space=0;
    my $hp_html_string="";
    while (@hp_regions) {
	($hp_start,$hp_end)=splice(@hp_regions,0,2);
	$hp_length=$hp_end-$hp_start;
	map {$_*=$width_scale; $_=int($_);} ($hp_start,$hp_end,$hp_length);
	$hp_length=1 if $hp_length<1;
	$hp_space=$hp_start-$hp_endpoint;
	$hp_html_string.="<IMG SRC=PROT_BACK.gif BORDER=0 HEIGHT=$height WIDTH=$hp_space>" if $hp_space;
	$hp_html_string.="<IMG SRC=PROT_HELIX.gif BORDER=1 HEIGHT=$height WIDTH=$hp_length>";
	$hp_endpoint=$hp_start+$hp_length;
    }
	$hp_space=$graphic_length-$hp_endpoint;
	$hp_html_string.="<IMG SRC=PROT_BACK.gif BORDER=0 HEIGHT=$height WIDTH=$hp_space>" if $hp_space;

    return "<A HREF=something>$hp_html_string</A>";
}

sub struct_ofO {
    my ($rid,$user,$mode)=@_;
    my $structure=&assigned_structureO($rid,$user,$mode);
    return $structure;
}

1;

